#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <dis.h>

char str[10][80];

typedef struct {
	int i;
	int j;
	int k;
	double d;
	short s;
	char c;
	short t;
	float f;
	char str[20];
}TT;

TT t;
/*
int big_buff[1024];
*/
void cmnd_rout(tag, buf, size)
int *tag, *size;
TT *buf;
{

	printf("Command received, size = %d, TT size = %d:\n", *size,
	       sizeof(TT));
	printf("buf->i = %i, buf->d = %d ,buf->s = %i, buf->c = %c, buf->f = %f, buf->str = %s\n \
			buf is the data which could be changed, it is the elements in TT struct t.\n \
			A client from outside DIM (your program is a server in dim) can\n \
				request the execution of this cmnd, so it can change this servers svc values.\n",
			buf->i, buf->d, buf->s, buf->c, buf->f, buf->str);
	/*every value is changed*/
	t.c = buf->c;
	t.d = buf->d;
	t.f = buf->f;
	t.i = buf->i;
	t.j = buf->j;
	t.k = buf->c;
	t.s = buf->s;
	strcpy( t.str, buf->str);
	t.t = buf->t;
	/*next step would be to inform other clients that values have changed
	 * -> update_service, look in main below.*/
}

void client_exited(tag)
int *tag;
{
	char name[84];

	if(dis_get_client(name))
		printf("Client %s (%d) exited\n", name, *tag);
	else
		printf("Client %d exited\n", *tag);
}

void exit_cmnd(code)
int *code;
{
	printf("Exit_cmnd %d\n", *code);
	exit(*code);
}

void addExitAndErrorHandler()
{
	/*add exit handler*/
	dis_add_exit_handler(exit_cmnd);
	dis_add_client_exit_handler(client_exited);
}

void setupStaticServices(argv)
char **argv;
{
	int i;
	for(i = 0; i< 10; i++)
	{
		sprintf(str[i],"%s/Service_%03d",argv[1],i);
		/*setting up some (static) services:
		 * svc with a name str[i] which, at the same time, is the data content (of type char) 
		 * the datatytpe is "C" = char*/
		dis_add_service( str[i], "C", str[i], strlen(str[i])+1, 
			(void *)0, 0 );
	}
}

int setupDynamicServices(argv)
char **argv;
{
	char aux[80];
	int id;
		/* setting the initial values of the next service you want to provide, which in this case is a struct with many different values*/
	t.i = 123;
	t.j = 123;
	t.k = 123;
	t.d = 56.78;
	t.s = 12;
	t.t = 12;
	t.c = 'a';
	t.f = (float)4.56;
	/*ptr = (int *)&t;*/
	strcpy(t.str,"hello world");

	sprintf(aux,"%s/TEST_SWAP",argv[1]);
	/*setting up a service which has the data type TT, with all the different single data types listed*/
	id = dis_add_service( aux, "l:3;d:1;s:1;c:1;s:1;f:1;c:20", &t, sizeof(t), 
		(void *)0, 0 );
	return id;
}

void setupCommands(argv)
char ** argv;
{
	char aux[80];
	sprintf(aux,"%s/TEST_CMD",argv[1]);
	/*setting up a cmnd, where cmnd_rout is the method invoked if this cmnd is received*/
	dis_add_cmnd(aux,"l:3;d:1;s:1;c:1;s:1;f:1;c:20",cmnd_rout, 1200);
}

int main(argc,argv)
int argc;
char **argv;
{
	/*fill in your source code here*/
	
	int id;

	addExitAndErrorHandler();
	setupStaticServices(argv);
	
	id = setupDynamicServices(argv);

	setupCommands(argv);

	/* start the ioc, serving all the initialised svc*/
	dis_start_serving( argv[1] );

	while(1)
	{
		/*no need to update the numerated services, because they are static, at the moment not to be changed by any cmnd.
		 * so you only udate the one changeable svc.*/
		dis_update_service(id);

		sleep(1);

		pause();
	}
}

